using System;
using System.IO;

namespace WidReader.Data
{
    /// <summary>
    /// Z摜P̃f[^B
    /// GAƔwiύXRegŎgB
    /// </summary>
    public class CellData : FileIO
    {

        #region vpeB
        /// <summary>
        /// 摜XW
        /// </summary>
        public int Left
        {
            get { return left; }
            set { left = value; }
        }
        int left;

        /// <summary>
        /// 摜YW
        /// </summary>
        public int Top
        {
            get { return top; }
            set { top = value; }
        }
        int top;

        /// <summary>
        /// 摜̕
        /// </summary>
        public int Width
        {
            get { return (int)(widthANDversion % Const.VersionOffset); }
            set { widthANDversion = (uint)value + Version * Const.VersionOffset; }
        }
        uint widthANDversion;
        /// <summary>
        /// f[^o[W
        /// </summary>
        public uint Version
        {
            get { return widthANDversion / Const.VersionOffset; }
            set { widthANDversion = (uint)Width + value * Const.VersionOffset; }
        }

        /// <summary>
        /// 摜̍
        /// </summary>
        public int Height
        {
            get { return (int)height; }
            set { height = (uint)value; }
        }
        uint height;

        /// <summary>
        /// Z摜̃t@C
        /// </summary>
        public string FileName
        {
            get { return file; }
            set { file = value; }
        }
        string file;

        /// <summary>
        /// }XNL
        /// </summary>
        public bool MaskOn
        {
            get { return !(mask == 0); }
            set { mask = (byte)(value ? 1 : 0); }
        }
        byte mask;

        /// <summary>
        /// QƃtO
        /// iNULLj
        /// (NULL = 01 00 00 00 00)
        /// </summary>
        public string FlagName
        {
            get { return flag; }
            set { flag = value; }
        }
        string flag;

        /// <summary>
        /// ԂǂB{tOŐ䂵vC[͒ڕύXłȂB
        /// </summary>
        public bool Visible
        {
            get { return !(visible == 0); }
            set { visible = (byte)(value ? 1 : 0); }
        }
        byte visible;

        #endregion

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            left = r.ReadInt32();
            top = r.ReadInt32();
            widthANDversion = r.ReadUInt32();
            height = r.ReadUInt32();
            file = r.ReadString();
            mask = r.ReadByte();
            flag = r.ReadString();
            visible = r.ReadByte();
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(left);
            w.Write(top);
            w.Write(widthANDversion);
            w.Write(height);
            w.Write(file);
            w.Write(mask);
            w.Write(flag);
            w.Write(visible);
        }
        #endregion

    }//class CellData
}
