using System;
using System.Collections.Specialized;
using System.Collections.Generic;

namespace WidReader.Data
{
    public class FlagIndexData : FileIO
    {

        #region vpeB
        public string FlagName
        {
            get { return name; }
            set { name = value; }
        }
        string name;
        public byte InitialValue
        {
            get { return initial; }
            set { initial = value; }
        }
        byte initial;
        public string[] ValueStrings
        {
            get { return values; }
        }
        string[] values = new string[2];
        #endregion

        public FlagIndexData() {  }

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            name = r.ReadString();
            initial = r.ReadByte();
            for (int k = 1; k >= 0; k--)
                values[k] = r.ReadString();
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(name);
            w.Write(initial);
            for (int k = 1; k >= 0; k--)
                w.Write(values[k]);
        }
        #endregion
    }

}
