using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace WidReader.Data
{

    public enum _IΏ : byte
    {
        p[eBS = 0x01, GS, tB[hS
    }

    public enum IΏۏ : byte
    {
        s\, ss, , 񐶑,
        N, , d, ӎs,
        , , , ჁEΉ,
        , V, E, Q
    }

    /// <summary>
    /// _IReg̃f[^
    /// </summary>
    public class RandomSelectContent : BaseContent
    {
        #region vpeB
        /// <summary>
        /// IΏ
        /// </summary>
        public _IΏ Target
        {
            get { return (_IΏ)b; }
        }

        /// <summary>
        /// IΏۃxl邩
        /// </summary>
        public bool WithLevel
        {
            get { return (flag & 0x01) != 0x00; }
        }
        byte flag = 0x00;

        /// <summary>
        /// Ώۍŏx
        /// </summary>
        private const uint TARGET_MIN_LEVEL = 1;
        /// <summary>
        /// Ώۍő僌x
        /// </summary>
        private const uint TARGET_MAX_LEVEL = 99;

        /// <summary>
        /// IΏۃxFrom
        /// </summary>
        public uint LevelFrom
        {
            get { return ui; }
            set
            {
                if (value < TARGET_MIN_LEVEL) ui = TARGET_MIN_LEVEL;
                else if (value > TARGET_MAX_LEVEL) ui = TARGET_MAX_LEVEL;
                else ui = value;
            }
        }
        /// <summary>
        /// IΏۃxTo
        /// </summary>
        public uint LevelTo
        {
            get { return uiTo; }
            set
            {
                if (value < TARGET_MIN_LEVEL) uiTo = TARGET_MIN_LEVEL;
                else if (value > TARGET_MAX_LEVEL) uiTo = TARGET_MAX_LEVEL;
                else uiTo = value;
            }
        }
        uint uiTo;

        /// <summary>
        /// IΏۏԂl邩
        /// </summary>
        public bool WithState
        {
            get { return (flag & 0x02) != 0x00; }
        }

        /// <summary>
        /// IΏۏ
        /// </summary>
        public IΏۏ State
        {
            get { return (IΏۏ)b; }
        }
        #endregion

        #region RXgN^
        public RandomSelectContent()
            : base(0x46)
        { ui = TARGET_MIN_LEVEL; uiTo = TARGET_MIN_LEVEL; }
        #endregion

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            // IΏ
            b = r.ReadByte();
            // ڍ׏tO
            flag = r.ReadByte();
            if (WithLevel)
            {
                // IΏۃx
                ui = r.ReadUInt32();
                uiTo = r.ReadUInt32();
            }
            if (WithState)
            {
                // IΏۂ̏
                b2 = r.ReadByte();
            }
        }
        public override void Write(ShiftJisWriter w)
        {
            // IΏ
            w.Write(b);
            // ڍ׏tO
            w.Write(flag);
            if (WithLevel)
            {
                // IΏۃx
                w.Write(ui);
                w.Write(uiTo);
            }
            if (WithState)
            {
                // IΏۂ̏
                w.Write(b2);
            }
        }
        #endregion
    }
}
