/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace WidReader.Data
{

    /// <summary>
    /// wiύXReg̃f[^
    /// </summary>
    public class ViewChangeContent : BaseContent
    {

        #region vpeB
        public List<CellData> Cells
        {
            get
            {
                return cellList;
            }
        }
        List<CellData> cellList = new List<CellData>();

        #endregion

        public ViewChangeContent() : base(0x08) { }

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                CellData cell = new CellData();
                cell.Read(r);
                Cells.Add(cell);
            }
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(Cells.Count);
            foreach (CellData cell in Cells)
                cell.Write(w);
        }
        #endregion
    }
}
