using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace WidReader.Data
{
    public class EventData : FileIO
    {

        #region vpeB
        /// <summary>
        /// RegXgiReg͓qȂ̂ŒӁj
        /// </summary>
        public List<ContentData> Starts
        {
            get
            {
                return startList;
            }
        }
        List<ContentData> startList = new List<ContentData>();

        /// <summary>
        /// ΏH
        /// </summary>
        bool fire;

        /// <summary>
        /// VXeΔԍXg
        /// </summary>
        public List<int> SystemFireNumbers
        {
            get
            {
                return systemFire;
            }
        }
        List<int> systemFire = new List<int>();

        /// <summary>
        /// L[R[hXgiΏj
        /// </summary>
        public StringCollection KeyCodes
        {
            get
            {
                return keycodeList;
            }
        }
        StringCollection keycodeList = new StringCollection();

        #endregion

        #region RXgN^

        /// <summary>
        /// CxgIuWFNg̃RXgN^
        /// </summary>
        public EventData() : this(true) { ;}

        /// <summary>
        /// CxgIuWFNg̃RXgN^
        /// </summary>
        /// <param name="isfire">
        /// ΏGAŐ^A
        /// pbP[WAgpCxg͋U
        /// </param>
        public EventData(bool isfire)
        {
            fire = isfire;
        }
        #endregion

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            //RegXg
            uint count = r.ReadUInt32();
            ContentData con;
            for (; count > 0; count--)
            {
                con = new ContentData();
                con.Read(r);
                Starts.Add(con);
            }

            if (fire)
            {
                //Ώ
                count = r.ReadUInt32();
                for (; count > 0; count--)
                {
                    SystemFireNumbers.Add(r.ReadInt32());
                }

                //L[R[hXgiΏj
                keycodeList = r.ReadStringCollection();
            }
        }
        public override void Write(ShiftJisWriter w)
        {
            //RegXg
            w.Write(Starts.Count);
            foreach (ContentData c in Starts)
                c.Write(w);

            if (fire)
            {
                //Ώ
                w.Write(SystemFireNumbers.Count);
                foreach (int i in SystemFireNumbers)
                    w.Write(i);

                //L[R[hXgiΏj
                w.Write(KeyCodes);
            }
        }
        #endregion

    }
}
