using System;
using System.Collections.Specialized;

namespace WidReader.Data
{
    /// <summary>
    /// l[ꂽJ[hƃJ[h̎cgp񐔁iACêݗLj̃f[^J[hB
    /// ۂɏL閇̃f[^݂B
    /// ̃f[^̓p[eB̉ו܏ƁAh̋ɏɌB
    /// CardIndexDataƂ͏ɘAB
    /// </summary>
    public class RenamedCardData : FileIO
    {
        #region tB[h
        string renamedCardName;
        uint count;
        byte fix;
        #endregion

        #region vpeB
        /// <summary>
        /// dȂ悤Ɍ()tꂽit@CpjJ[h
        /// </summary>
        public string RenamedName
        {
            get { return renamedCardName; }
            set { renamedCardName = value; }
        }
        /// <summary>
        /// ACe̎cgp񐔁iACeȊOł͂Oj
        /// </summary>
        public uint UseCount
        {
            get { return count; }
            set { count = value; }
        }
        /// <summary>
        /// mrbgiF9ΏۊOjiKtrueHjƑ̂̂Ȃ
        /// </summary>
        public bool FixPossession
        {
            get { return (fix == 1); }
            set { fix = (byte)(value ? 1 : 0); }
        }
        #endregion

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            renamedCardName = r.ReadString();
            count = r.ReadUInt32();
            fix = r.ReadByte();
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(renamedCardName);
            w.Write(count);
            w.Write(fix);
        }
        #endregion

    }//class RenamedCardData
}
